config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :friends
  get 'home/index'
  get 'home/about'
  root 'friends#index'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/friend.rb
class Friend < ApplicationRecord
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

          has_many :friends
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/friends_controller.rb
class FriendsController < ApplicationController
  before_action :set_friend, only: %i[ show edit update destroy ]
  before_action :authenticate_user!, except: [:index, :show]
  before_action :correct_user, only: [:edit, :update, :destroy]

  # GET /friends or /friends.json
  def index
    @friends = Friend.all
  end

  # GET /friends/1 or /friends/1.json
  def show
  end

  # GET /friends/new
  def new
    # @friend = Friend.new
    @friend = current_user.friends.build
  end

  # GET /friends/1/edit
  def edit
  end

  # POST /friends or /friends.json
  def create
    # @friend = Friend.new(friend_params)
    @friend = current_user.friends.build(friend_params)
    respond_to do |format|
      if @friend.save
        format.html { redirect_to @friend, notice: "Friend was successfully created." }
        format.json { render :show, status: :created, location: @friend }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @friend.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /friends/1 or /friends/1.json
  def update
    respond_to do |format|
      if @friend.update(friend_params)
        format.html { redirect_to @friend, notice: "Friend was successfully updated." }
        format.json { render :show, status: :ok, location: @friend }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @friend.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /friends/1 or /friends/1.json
  def destroy
    @friend.destroy
    respond_to do |format|
      format.html { redirect_to friends_url, notice: "Friend was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  def correct_user
    @friend = current_user.friends.find_by(id: params[:id])
    redirect_to friends_path, notice: "Not Authorized To Edit This Friend" if @friend.nil?
  end



  private
    # Use callbacks to share common setup or constraints between actions.
    def set_friend
      @friend = Friend.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def friend_params
      params.require(:friend).permit(:first_name, :last_name, :email, :phone, :twitter, :user_id)
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end

  def about
    @about_me = "This is a good practice"
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/friends_helper.rb
module FriendsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/friends/_form.html.erb
<%= form_with(model: friend) do |form| %>
  <% if friend.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(friend.errors.count, "error") %> prohibited this friend from being saved:</h2>

      <ul>
        <% friend.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field form-group">
    <%= form.text_field :first_name, class: "form-control", placeholder: "First Name" %>
  </div>

  <div class="field form-group">
    <%= form.text_field :last_name, class: "form-control", placeholder: "Last Name" %>
  </div>

  <div class="field form-group">
    <%= form.text_field :email, class: "form-control", placeholder: "Email" %>
  </div>

  <div class="field form-group">
    <%= form.text_field :phone, class: "form-control", placeholder: "Phone" %>
  </div>

  <div class="field form-group">
    <%= form.text_field :twitter, class: "form-control", placeholder: "Twitter" %>
  </div><div class="field form-group">
    <%= form.number_field :user_id, id: :friend_user_id, class: "form-control", value: current_user.id, type: :hidden %>
  </div>
  <br />

  <div class="actions">
    <%= form.submit class: "btn btn-secondary" %>
  </div>
<% end %>

app/views/friends/edit.html.erb
<h1>Editing Friend</h1>
<br />
<%= render 'form', friend: @friend %>
<br />
<%= link_to 'Show', @friend, class: "btn btn-primary" %>
<%= link_to 'Back', friends_path, class: "btn btn-secondary" %>
<%= link_to 'Delete', @friend, class: "btn btn-danger", method: :delete, data: { confirm: 'Are you sure?' } %>

app/views/friends/index.html.erb
<% if user_signed_in?%>
  <table class="table table-striped table-bordered table-hover">
    <thead class="table-dark">
      <tr>
        <th>Name</th>
        <th>Email</th>
        <th>Phone</th>
        <th>Twitter</th>
        <th>User Id</th>
        <th colspan="3"></th>
      </tr>
    </thead>

    <tbody>
      <% @friends.each do |friend| %>
        <% if friend.user == current_user%>
          <tr>
            <td><%= link_to friend.first_name + ' ' + friend.last_name, friend %></td>
            <td><%= friend.email %></td>
            <td><%= friend.phone %></td>
            <td><%= friend.twitter %></td>
            <td><%= friend.user_id %></td>
            <td><%= link_to 'Edit', edit_friend_path(friend) %></td>
            <td><%= link_to 'Delete', friend, class: "btn btn-outline-danger btn-sm", method: :delete, data: { confirm: 'Are you sure?' } %></td>
          </tr>
        <% end%>
      <% end %>
    </tbody>
  </table>
<% else%>
  <h1>Hello world</h1>
    This is my first Rails Webpage
<% end%>
<br>

<%= link_to 'New Friend', new_friend_path, class: "btn btn-secondary" %>

app/views/friends/new.html.erb
<h1>Add New Friend</h1>
<br />

<%= render 'form', friend: @friend %>
<br />
<%= link_to 'Back', friends_path, class: "btn btn-dark" %>

app/views/friends/show.html.erb
<div class="jumbotron bg-info">
  <h1 class="display-4">
    <%= @friend.first_name %>
    <%= @friend.last_name %>
  </h1>
  <%= @friend.email %> | <%= @friend.phone %> | <%= @friend.twitter %>

  <hr class="my-4">
  <br/>
  <p class="lead">
    <%= link_to 'Edit', edit_friend_path(@friend), class: "btn btn-secondary" %>
    <%= link_to 'Back', friends_path, class: "btn btn-dark" %>
  </p>
</div>

app/views/home/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">
  <%= link_to 'Friends App', root_path, class: "navbar-brand"%>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <%= link_to 'About Us', home_about_path, class: "nav-link"%>
        </li>

        <% if user_signed_in? %>
          <li class="nav-item">
            <%= link_to 'Add Friend', new_friend_path, class: "nav-link"%>
          </li>
          <li class="nav-item">
            <%= link_to 'Sign out', destroy_user_session_path, method: :delete, class: "nav-link"%>
          </li>
          <li class="nav-item">
            <%= link_to 'Edit profile', edit_user_registration_path, class: "nav-link"%>
          </li>
        <% else%>
          <li class="nav-item">
            <%= link_to 'Friends', friends_path, class: "nav-link"%>
          </li>
          <li class="nav-item">
            <%= link_to 'Sign up', new_user_registration_path, class: "nav-link"%>
          </li>
          <li class="nav-item">
            <%= link_to 'Sign in', new_user_session_path, class: "nav-link"%>
          </li>
        <% end%>


      </ul>
      <form class="d-flex">
        <input class="form-control me-2" type="search" placeholder="Search" aria-label="Search">
        <button class="btn btn-outline-success" type="submit">Search</button>
      </form>
    </div>
  </div>
</nav>

app/views/home/about.html.erb
<h1>About us...</h1>
<%= @about_me%>

app/views/home/index.html.erb
<h1>Hello world</h1>
This is my first Rails Webpage

app/views/layouts/_alerts.html.erb
<div class="alert alert-warning alert-dismissible fade show" role="alert">
  <%= notice%>
  <button type="button" class="close" data-dismiss="alert" aria-label="Close">
    <span aria-hidden="true">&times;</span>
  </button>
</div>

app/views/layouts/application.html.erb
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-BmbxuPwQa2lc/FVzBcNJ7UAyJxM6wuqIj61tLrc4wSX0szH/Ev+nYRRuWlolflfl" crossorigin="anonymous">

    <title>Friends App</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>
  </head>
  <body>
  <%= render 'home/header'%>
    <div class="container">
    <br/>
    <% if notice%>
      <%= render 'layouts/alerts'%>
    <% end%>
     <%= yield %>
    </div>

    <!-- Optional JavaScript; choose one of the two! -->

    <!-- Option 1: Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/js/bootstrap.bundle.min.js" integrity="sha384-b5kHyXgcpbZJO/tY9Ul7kGkf1S0CWuKcCD38l8YkeH8z8QjE0GmW1gYU5S9FOnJ0" crossorigin="anonymous"></script>

    <!-- Option 2: Separate Popper and Bootstrap JS -->
    <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.6.0/dist/umd/popper.min.js" integrity="sha384-KsvD1yqQ1/1+IA7gi3P0tyJcT3vR+NdBTt13hSJ2lnve8agRGXTTyNaBYmCR/Nwi" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/js/bootstrap.min.js" integrity="sha384-nsg8ua9HAw1y0W1btsyWgBklPnCUAFLuTMS2G72MMONqmOymq585AcH49TLBQObG" crossorigin="anonymous"></script>
    -->
  </body>
</html>